/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// V3DeploymentLister helps list V3Deployments.
type V3DeploymentLister interface {
	// List lists all V3Deployments in the indexer.
	List(selector labels.Selector) (ret []*v1.V3Deployment, err error)
	// V3Deployments returns an object that can list and get V3Deployments.
	V3Deployments(namespace string) V3DeploymentNamespaceLister
	V3DeploymentListerExpansion
}

// v3DeploymentLister implements the V3DeploymentLister interface.
type v3DeploymentLister struct {
	indexer cache.Indexer
}

// NewV3DeploymentLister returns a new V3DeploymentLister.
func NewV3DeploymentLister(indexer cache.Indexer) V3DeploymentLister {
	return &v3DeploymentLister{indexer: indexer}
}

// List lists all V3Deployments in the indexer.
func (s *v3DeploymentLister) List(selector labels.Selector) (ret []*v1.V3Deployment, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.V3Deployment))
	})
	return ret, err
}

// V3Deployments returns an object that can list and get V3Deployments.
func (s *v3DeploymentLister) V3Deployments(namespace string) V3DeploymentNamespaceLister {
	return v3DeploymentNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// V3DeploymentNamespaceLister helps list and get V3Deployments.
type V3DeploymentNamespaceLister interface {
	// List lists all V3Deployments in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.V3Deployment, err error)
	// Get retrieves the V3Deployment from the indexer for a given namespace and name.
	Get(name string) (*v1.V3Deployment, error)
	V3DeploymentNamespaceListerExpansion
}

// v3DeploymentNamespaceLister implements the V3DeploymentNamespaceLister
// interface.
type v3DeploymentNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all V3Deployments in the indexer for a given namespace.
func (s v3DeploymentNamespaceLister) List(selector labels.Selector) (ret []*v1.V3Deployment, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.V3Deployment))
	})
	return ret, err
}

// Get retrieves the V3Deployment from the indexer for a given namespace and name.
func (s v3DeploymentNamespaceLister) Get(name string) (*v1.V3Deployment, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("v3deployment"), name)
	}
	return obj.(*v1.V3Deployment), nil
}
